<template>
    <v-col cols='3' style="min-width:256px" class='pa-1'>
        <v-card :loading="loading" min-width="256" class="fill-height">
          <v-card-title>
            Register
          </v-card-title>
          <v-card-text>
            <v-text-field 
                :disabled="loading" 
                type="text" 
                :error-messages="hasError || null" 
                placeholder="login" 
                v-model="login"
                :rules="[rules.required, rules.min]"
            ></v-text-field>
            <v-text-field 
                :disabled="loading" 
                :type="showPass ? 'text' : 'password'"
                :rules="[rules.required, rules.min]"
                placeholder="password" 
                v-model="password"
                :append-icon="showPass ? 'mdi-eye' : 'mdi-eye-off'"
                @click:append="showPass = !showPass"
            ></v-text-field>
            <v-btn @click="doRegister" :disabled="loading" color="success">Register</v-btn>
          </v-card-text>
        </v-card>
    </v-col>
</template>

<script>
export default {
    name: "register-card",
    data() {
        return {
            hasError: "",
            login: "",
            password: "",
            loading: false,
            showPass: false,
            rules: {
                required: value => !!value || 'Required.',
                min: v => v.length >= 8 || 'Min 8 characters',
            },
        }
    },
    methods: {
        async doRegister () {
            if (this.login && this.password) {
                this.loading = true
                this.hasError = ""
                this.$store.dispatch("register", {
                    login: this.login,
                    password: this.password
                })
            } else {
                this.hasError = "Both fields are required"
            } 
        },
    },
    sockets: {
        async signUpResponse(data) {
            this.loading = false
            console.log('Got sign up response', data.success)
            if (data.success === true) {
                this.$store.dispatch("enqueueSnackMessage", {
                    str: "You were successfully signed up. Log in to continue",
                    color: "success",
                    id: "RegisterSuccess"
                })
                this.login = ""
                this.password = ""
            } else {
                this.$store.dispatch("enqueueSnackMessage", {
                    str: "An error occured while trying to register you. Please try again later",
                    color: "red",
                    id: "RegisterSuccess"
                })
                this.hasError = "Can't register you"
            }
        }
    }
}
</script>